More is better (并查集)

More is better


纯属个人理解:
Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 327680/102400 K (Java/Others)
Total Submission(s): 28561    Accepted Submission(s): 10151


Problem Description
Mr Wang wants some boys to help him with a project. Because the project is rather complex, the more boys come, the better it will be. Of course there are certain requirements.

Mr Wang selected a room big enough to hold the boys. The boy who are not been chosen has to leave the room immediately. There are 10000000 boys in the room numbered from 1 to 10000000 at the very beginning. After Mr Wang's selection any two of them who are still in this room should be friends (direct or indirect), or there is only one boy left. Given all the direct friend-pairs, you should decide the best way.
 

Input
The first line of the input contains an integer n (0 ≤ n ≤ 100 000) - the number of direct friend-pairs. The following n lines each contains a pair of numbers A and B separated by a single space that suggests A and B are direct friends. (A ≠ B, 1 ≤ A, B ≤ 10000000)
 

Output
The output in one line contains exactly one integer equals to the maximum number of boys Mr Wang may keep. 
 

Sample Input

4 1 2 3 4 5 6 1 6 4 1 2 3 4 5 6 7 8
 

Sample Output

4 2
Hint
A and B are friends(direct or indirect), B and C are friends(direct or indirect), then A and C are also friends(indirect). In the first sample {1,2,5,6} is the result. In the second sample {1,2},{3,4},{5,6},{7,8} are four kinds of answers.
 

Author
lxlcrystal@TJU
 

Source
HDU 2007 Programming Contest - Final


题意
输入的一对数是好朋友,他们可以站在一起,最后让求的是每一组中人数的最大值;
par【x】=w;表示x的好朋友是w; 则他们可以站在一起;
num【x】=q; 表示x的好朋友个数为q,间接的也可以 比如1和2,2和3  所以1和3也是好朋友;  


#include
#include
#include
using namespace std;
int par[10000010],num[10000010];


void init(int n)//初始化 
{
int i;
for(i=0;i<=n;i++)
{
par[i]=i;
num[i]=1;
}
}


int find(int x)/*寻找根节点*/ 
{
if(par[x]==x) return x;
    int t=par[x];
par[x]=find(t);
num[x]+=num[t];
return  par[x];
}


int n;


int main()
{
while(scanf("%d",&n)!=EOF)
{
int ss=0;
init(10000001);
//当n为0时,只有1个人; 
if(n==0)
{
printf("1\n");
continue;
}
int a,b; 
while(n--)
{
cin>>a>>b;
int ax=find(a);
int ay=find(b);
if(ax!=ay)
{
/*合并a和b*/  
par[ay]=ax;
/*合并集合中元素个数*/  
num[ax]+=num[ay];
//更新最大值 
ss=max(ss,num[ax]);
}
}
printf("%d\n",ss);
}
}


人一我百!人十我万!永不放弃~~~怀着自信的心,去追逐梦想。




你可能感兴趣的:(并查集)